﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.Plugins;
using System.Threading;
using System.Globalization;
using Styx.Common;
using System.Diagnostics;
using Styx.WoWInternals.WoWObjects;
using Styx;
using System.IO;
using System.Windows.Forms;
using System.Windows.Media;
using Styx.CommonBot;
using Styx.Common.Helpers;
using Styx.WoWInternals;

namespace ShutUp
{
    public class ShutUp : HBPlugin
    {
        #region Nothing to see here!

        public override string Author { get { return "BarryDurex, fixed by Trainerbert"; } }
        public override Version Version { get { return new Version(2, 0, 140); } }
        public override string Name { get { return "[ShutUp]"; } }
        public override string ButtonText { get { return "[ShutUp - Settings]"; } }
        public override bool WantButton { get { return true; } }

        private bool initialized = false;
        public Stopwatch loopTimer = new Stopwatch();
        private readonly WaitTimer _updateList = new WaitTimer(TimeSpan.FromMinutes(2));
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public string ShutUpLogLocation = (Application.StartupPath + "\\Plugins\\ShutUp\\Logs\\ShutUp_" + Me.Name + ".txt");
        public string Forumlink = "";
        private Thread newThread;

        public void dlog(string message, params object[] args)
        { dlog(LogLevel.Diagnostic, message, args); }

        public void dlog(LogLevel logLvl, string message, params object[] args)
        { /*slog(Colors.Red, "error - look in the HB-Log");*/ Logging.Write(logLvl, Colors.Firebrick, DateTime.Now.ToShortTimeString() + " - " + Name + ": " + message, args); }

        public void slog(Color color, string message, params object[] args)
        { Logging.Write(color, Name + ": " + message, args); }

        public void slog(string message, params object[] args)
        { Logging.Write(Colors.Orchid, Name + ": " + message, args); }


            public override void OnEnable()
            {
            base.OnEnable();
            { Logging.Write(Colors.White, "ShutUp Enabled"); }

            NotifyIconHelper.Initialize();

            FriendsList.Update();
            _updateList.Reset();

            #region File.Create(ShutUpLogLocation)
            if (!File.Exists(ShutUpLogLocation))
            {
                try
                {
                    File.Create(ShutUpLogLocation);
                }
                catch (Exception ex)
                {
                    slog(Colors.Red, "can not creat logfile");
                    slog(Colors.Red, "##################");
                    slog(Colors.Red, "{0}", ex);
                }
            }
            #endregion

            BotEvents.OnBotStopped += stopBot;
            BotEvents.OnBotStarted += startBot;

            dlog("- Initialized");
        }

        private void startBot(EventArgs args)
        {
            dlog("- startBot");
            loopTimer.Stop();
            Chat.Whisper += ChatHelper.newChat_Whisper;
            Chat.Party += ChatHelper.newChat_Party;
            Chat.PartyLeader += ChatHelper.newChat_Party;
            Chat.Guild += ChatHelper.newChat_Guild;
            Chat.Say += ChatHelper.newChat_Say;
            Chat.Yell += ChatHelper.newChat_Yell;
            Chat.Battleground += ChatHelper.newChat_Battleground;
            Chat.Raid += ChatHelper.newChat_Raid;
            Chat.RaidLeader += ChatHelper.newChat_Raid;
            Chat.Officer += ChatHelper.newChat_Officer;
            Chat.RaidWarning += ChatHelper.newChat_Raid;
            Lua.Events.AttachEvent("CHAT_MSG_BN_WHISPER", ChatHelper.newChat_BNWhisper);

            //NotifyIconHelper.Initialize();
            if (!NotifyIconHelper.NotifyIcn.Visible)
            { NotifyIconHelper.NotifyIcn.Visible = true; NotifyIconHelper.NotifyIcn.ShowBalloonTip(3500, "[ShutUp]", "You will find [ShutUp] here.", ToolTipIcon.Info); }
        }

        private void stopBot(EventArgs args)
        {
            dlog("- stopBot");
            Chat.Whisper -= new Chat.ChatMessageHandlerEx<Chat.ChatWhisperEventArgs>(ChatHelper.newChat_Whisper);
            Chat.Party -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Party);
            Chat.PartyLeader -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Party);
            Chat.Say -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Say);
            Chat.Guild -= new Chat.ChatMessageHandlerEx<Chat.ChatGuildEventArgs>(ChatHelper.newChat_Guild);
            Chat.Yell -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Yell);
            Chat.Battleground -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Battleground);
            Chat.Raid -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Raid);
            Chat.RaidLeader -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Raid);
            Chat.Officer -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Officer);
            Chat.RaidWarning -= new Chat.ChatMessageHandlerEx<Chat.ChatLanguageSpecificEventArgs>(ChatHelper.newChat_Raid);
            Lua.Events.DetachEvent("CHAT_MSG_BN_WHISPER", ChatHelper.newChat_BNWhisper);
            NotifyIconHelper.NotifyIcn.Visible = false;
        }

        public override void OnDisable()
        {
            base.OnDisable();
            { Logging.Write(Colors.White, "ShutUp Disabled"); }
            {
                try
                {
                    //System.Media.SystemSounds.Asterisk.Play();
                    newThread.Abort();
                    FriendsList.newThread.Abort();
                    //if (ChatHelper._timer.Enabled)
                    //    ChatHelper._timer.Stop();
                    NotifyIconHelper.NotifyIcn.Visible = false;
                    NotifyIconHelper.NotifyIcn.Dispose();
                }
                catch (Exception ex) { }
                dlog("- OnDisable");
            }
        }



        #endregion

        #region on button press
        public override void OnButtonPress()
        {
            var _configForm = new SettingsForm();
            _configForm.ShowDialog();
        }
        #endregion

        public override void Pulse()
        {
            #region update friedslists
            if (!Me.Combat && _updateList.IsFinished)
            { _updateList.Reset(); FriendsList.Update(); }
            #endregion

            #region sound loop
            if (loopTimer.IsRunning && loopTimer.ElapsedMilliseconds > (ShutUpSettings.Instance.SoundLoopEvery * 1000))
            {
                dlog("sound loop \n\nloop: {0}", ChatHelper.loop);
                loopTimer.Reset(); loopTimer.Start();
                ChatHelper.loop++;
                ChatHelper.PlaySound(ChatHelper.soundLoopStatus);

                if (ChatHelper.loop == ShutUpSettings.Instance.SoundLoop) { ChatHelper.loop = 0; loopTimer.Stop(); }
            }
            #endregion
        }
    }
}
